<template>
  <div>
    <Modal
      :isDisplayed="modal"
      @cancel="closeModal"
      @save="saveChange"
      :item="product"
    />
    <Header />
    <main class="p-4 full-h-screen flex flex-col" v-if="isLoaded">
      <SearchBar
        class="mb-5"
        @search="searchProduct"
        :items="productsSearched"
      />
      <div class="flex mb-3">
        <h2 class="text-xl font-semibold mr-3">{{ $t("My products") }}</h2>
        <button
          @click="changeOrder('asc')"
          :class="
            orderBy === 'asc'
              ? 'bg-blue-100 pointer-events-none'
              : 'bg-gray-200'
          "
          class="focus:outline-none px-2 py-1 rounded mr-2"
        >
          {{ $t("Les plus récents") }}
        </button>
        <button
          @click="changeOrder('desc')"
          :class="
            orderBy === 'desc'
              ? 'bg-blue-100 pointer-events-none'
              : 'bg-gray-200'
          "
          class="focus:outline-none px-2 py-1 rounded mr-2"
        >
          {{ $t("Les plus anciens") }}
        </button>
        <router-link
          :to="{ name: 'create' }"
          class="px-2 py-1 font-semibold hover:underline"
        >
          {{ $t("Create product") }}
        </router-link>
      </div>
      <div class="flex items-center justify-center mb-16">
        <div
          v-for="product in productsPaginate"
          class="w-52 flex flex-col items-center justify-between m-4 shadow"
          :key="product.id"
        >
          <button
            @click="openModal(product)"
            class="
              p-2
              bg-red-600
              rounded-md
              text-white
              self-end
              hover:bg-red-700
            "
          >
            X
          </button>
          <div class="w-52 h-60">
            <img
              class="w-52 h-60 object-fit"
              :src="product.image"
              :alt="product.title"
            />
          </div>
          <h3
            @click="$router.push({ name: 'edit', params: { id: product.id } })"
            class="
              w-full
              h-22
              self-end
              bg-gray-300
              text-center
              font-medium
              rounded-b-md
              p-2
              hover:underline
              cursor-pointer
            "
          >
            {{ products[0].title }} - {{ product.id }}
          </h3>
        </div>
      </div>
      <Paginate
        class="self-center"
        @next="nextProducts"
        @previous="previousProducts"
      />
    </main>
    <div class="full-h-screen" v-else>
      <Loader class="h-full" />
    </div>
    <Footer />
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { Component, Watch } from "vue-property-decorator";
import axios from "axios";
import Header from "./_includes/Header.vue";
import Footer from "./_includes/Footer.vue";
import Paginate from "@/components/Paginate.vue";
import Modal from "@/components/Modal.vue";
import SearchBar from "@/components/SearchBar.vue";
import Loader from "@/components/Loader.vue";
import { Limit, Product } from "@/types/product";

@Component({
  components: {
    Header,
    Footer,
    Paginate,
    Modal,
    SearchBar,
    Loader,
  },
})
export default class Home extends Vue {
  private isLoaded = false;
  private modal = false;
  private productsPaginate: Product[] = [];
  private productsSearched: Product[] = [];
  private product: Product = {
    id: 0,
    title: "",
    description: "",
    price: 0,
    image: "",
    category: "",
  };
  private products: Product[] = [];
  private orderBy = "asc";
  private limit: Limit = {
    min: 0,
    max: 5,
  };

  private searchProduct(value: string): void | Product[] {
    if (value.length === 0) return (this.productsSearched = []);
    this.productsSearched = this.products.filter((product) =>
      product.title.includes(value)
    );
    this.productsSearched = this.productsSearched.splice(0, 10);
  }

  private nextProducts(value: number): void {
    if (this.limit.max < this.products.length) {
      this.limit.min += value;
      this.limit.max += value;

      this.paginateProducts();
    }
  }

  private previousProducts(value: number): void {
    if (this.limit.min > 0) {
      this.limit.min -= value;
      this.limit.max -= value;

      this.paginateProducts();
    }
  }

  private paginateProducts(): void {
    this.productsPaginate = [];
    this.productsPaginate = this.products.slice(this.limit.min, this.limit.max);
  }

  private changeOrder(value: string): string {
    return (this.orderBy = value);
  }

  private openModal(product: Product): void {
    this.product = product;
    this.modal = true;
  }

  private closeModal(): void {
    this.modal = false;
  }

  private async saveChange(value: Product): Promise<void> {
    try {
      await axios.delete(`https://fakestoreapi.com/products/${value.id}`);
      const productIndex = this.products.findIndex(
        (product) => product.id === value.id
      );
      this.products.splice(productIndex, 1);
      this.paginateProducts();
    } catch (e) {
      console.log(e);
    } finally {
      this.modal = false;
    }
  }

  @Watch("orderBy", { immediate: true })
  private async handle(value: string): Promise<void> {
    try {
      const { data } = await axios.get(
        `https://fakestoreapi.com/products?sort=${this.orderBy}`
      );
      this.products = data;
      this.paginateProducts();
    } catch (e) {
      console.log(e);
    } finally {
      this.isLoaded = true;
    }
  }
}
</script>
